<?php
//defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );
if( !defined( '_VALID_MOS' ) && !defined( '_JEXEC' ) ) die( 'Direct Access to '.basename(__FILE__).' is not allowed.' );
/**
*
* @version $Id: ps_telepago4b.php,v 1.1 2007/09/06 18:24:13 celano Exp $
* @package VirtueMart
* @subpackage payment
* @copyright Copyright (C) 2004-2005 Soeren Eberhardt. All rights reserved.
* @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php
* VirtueMart is free software. This version may have been modified pursuant
* to the GNU General Public License, and as distributed it includes or
* is derivative of works licensed under the GNU General Public License or
* other free or open source software licenses.
* See /administrator/components/com_virtuemart/COPYRIGHT.php for copyright notices and details.
*
* http://virtuemart.net

*Original Code By Jos Celano (josecelano)
*Modified/Improved by Yos Okusanya
*Email: yosolu@sankuru.biz
*License: GPL - General Public License
*
*/

/**
* This class implements the configuration panel for sistema 4B
* 
*/
class ps_4b {

    var $classname = "ps_4b";
    var $payment_code = "S4B";
	
  
    /**
    * Show all configuration parameters for this payment method
    * @returns boolean False when the Payment method has no configration
    */
    function show_configuration() {
        global $VM_LANG;
        $db = new ps_DB();
		
		jimport('joomla.filesystem.file');
        
        /** Read current Configuration ***/
		include_once(CLASSPATH ."payment/".$this->classname.".cfg.php");
		
		//getl active anguage 
		$lang =& JFactory::getLanguage();
		$active_lang = trim($lang->get('backwardlang'));

		// Load the language file		
		if( file_exists(CLASSPATH ."../languages/s4b/".$active_lang.'.php')) {
			include_once(CLASSPATH ."../languages/s4b/".$active_lang.'.php');
		} 
		else {
			include_once(CLASSPATH ."../languages/s4b/english.php");
		}
		
	
    ?>
    <table class="adminform">
       
	<!-- ========================================================================-->
	<tr>
        <td><strong><?php echo PHPSHOP_ADMIN_S4B_TESTMODE ?></strong></td>
            <td>
                <select name="S4B_SIMULATION_SITE" class="inputbox" >
                <option <?php if (S4B_SIMULATION_SITE == '1') echo "selected=\"selected\""; ?> value="1"><?php echo $VM_LANG->_('PHPSHOP_ADMIN_CFG_YES') ?></option>
                <option <?php if (S4B_SIMULATION_SITE != '1') echo "selected=\"selected\""; ?> value="0"><?php echo $VM_LANG->_('PHPSHOP_ADMIN_CFG_NO') ?></option>
                </select>
            </td>
			
            <td><?php echo PHPSHOP_ADMIN_S4B_S4B_DEBUG_TIP ?></td>
        </tr>
	<tr>
        <td><strong><?php echo PHPSHOP_ADMIN_S4B_EXTENSIVE_LOG ?></strong></td>
            <td>
                <select name="S4B_EXT_LOG" class="inputbox" >
                <option <?php if (S4B_EXT_LOG == '1') echo "selected=\"selected\""; ?> value="1"><?php echo $VM_LANG->_('PHPSHOP_ADMIN_CFG_YES') ?></option>
                <option <?php if (S4B_EXT_LOG != '1') echo "selected=\"selected\""; ?> value="0"><?php echo $VM_LANG->_('PHPSHOP_ADMIN_CFG_NO') ?></option>
                </select>
            </td>
			<td><?php echo PHPSHOP_ADMIN_S4B_EXTENSIVE_LOG_EXPLAIN ?>
        </tr>	
		<tr>
		
        <td><strong><?php echo PHPSHOP_ADMIN_S4_STORE ?></strong></td>
            <td>
                <input type="text" name="S4B_STORE_ID" class="inputbox" value="<?php  echo S4B_STORE_ID ?>" />
            </td>
            <td><?php echo PHPSHOP_ADMIN_S4_STORE_EXPLAIN ?>
            </td>
        </tr>
		
		<tr>
		
			<td><strong><?php echo PHPSHOP_ADMIN_S4_STORE_PASSWORD ?></strong></td>
            <td>
                <input type="password" name="S4B_STORE_PASSWORD" class="inputbox" value="<?php  echo S4B_STORE_PASSWORD ?>" />
            </td>
            <td><?php echo PHPSHOP_ADMIN_S4_STORE_PASSWORD_EXPLAIN ?>
            </td>
        </tr>
		
	<!-- ======================== server address ============================= -->
		<tr>
		
			<td><strong><?php echo PHPSHOP_ADMIN_S4B_SERVER_URL ?></strong></td>
            <td>
                <input type="text" name="S4B_PROD_SERVER_URL" class="inputbox" value="<?php  echo S4B_PROD_SERVER_URL ?>" />
            </td>
            <td><?php echo PHPSHOP_ADMIN_S4B_SERVER_URL_EXPLAIN ?>
            </td>
        </tr>
		
		<tr>
		
			<td><strong><?php echo PHPSHOP_ADMIN_S4B_SERVER_IP ?></strong></td>
            <td>
                <input type="text" name="S4B_PROD_SERVER_IP" class="inputbox" value="<?php  echo S4B_PROD_SERVER_IP ?>" />
            </td>
            <td><?php echo PHPSHOP_ADMIN_S4B_SERVER_IP_EXPLAIN ?>
            </td>
        </tr>
		
		<tr>
		
			<td><strong><?php echo PHPSHOP_ADMIN_S4B_SIMULATION_URL ?></strong></td>
            <td>
                <input type="text" name="S4B_SIMULATION_URL" class="inputbox" value="<?php  echo S4B_SIMULATION_URL ?>" />
            </td>
            <td><?php echo PHPSHOP_ADMIN_S4B_SIMULATION_URL_EXPLAIN ?>
            </td>
        </tr>
		
		<tr>
		
			<td><strong><?php echo PHPSHOP_ADMIN_S4B_SIMULATION_IP ?></strong></td>
            <td>
                <input type="text" name="S4B_SIMULATION_IP" class="inputbox" value="<?php echo S4B_SIMULATION_IP?>" />
            </td>
            <td><?php echo PHPSHOP_S4B_SIMULATION_IP_EXPLAIN ?>
            </td>
        </tr>
<?php
/*		
		<tr>
			<td><strong><?php echo PHPSHOP_S4B_ADVANCE_SECURITY ?></strong></td>
		  <td>
                <select name="S4B_ADVANCE_SECURITY" class="inputbox" >
	                <option <?php if (S4B_ADVANCE_SECURITY == '1') echo "selected=\"selected\""; ?> value="1"><?php echo $VM_LANG->_('PHPSHOP_ADMIN_CFG_YES') ?></option>
	                <option <?php if (S4B_ADVANCE_SECURITY != '1') echo "selected=\"selected\""; ?> value="0"><?php echo $VM_LANG->_('PHPSHOP_ADMIN_CFG_NO') ?></option>
                </select>
            </td>
			 <td><?php echo PHPSHOP_S4B_ADVANCE_SECURITY_EXPLAIN ?>
		</tr>
		<tr>		
			<td><strong><?php echo PHPSHOP_ADMIN_S4B_PUBLIC_KEY ?></strong></td>
            <td>
                <input type="text" name="S4B_PUBLIC_KEY" class="inputbox" value="<?php  echo S4B_PUBLIC_KEY ?>" />
            </td>
            <td><?php echo PHPSHOP_ADMIN_S4B_PUBLIC_KEY_EXPLAIN ?>
            </td>
        </tr>
*/
?>		
	<!-- ==========================================================================================-->	
		
		<tr>
			<td><strong><?php echo PHPSHOP_ADMIN_S4_SINGLE_LANG ?></strong></td>
			<td>
                <select name="S4B_TRANSACTION_LANG" class="inputbox" >
	                <option <?php if (S4B_TRANSACTION_LANG == 'es') echo "selected=\"selected\""; ?> value="es"><?php echo PHPSHOP_S4B_LANG_ES ?></option>
	                <option <?php if (S4B_TRANSACTION_LANG == 'en') echo "selected=\"selected\""; ?> value="en"><?php echo PHPSHOP_S4B_LANG_EN ?></option>
					<option <?php if (S4B_TRANSACTION_LANG == 'fr') echo "selected=\"selected\""; ?> value="fr"><?php echo PHPSHOP_S4B_LANG_FR ?></option>
	                <option <?php if (S4B_TRANSACTION_LANG == 'ca') echo "selected=\"selected\""; ?> value="ca"><?php echo PHPSHOP_S4B_LANG_CA ?></option>
                </select>
            
                <select name="S4B_SINGLE_LANG" class="inputbox" >
	                <option <?php if (S4B_SINGLE_LANG == '1') echo "selected=\"selected\""; ?> value="1"><?php echo $VM_LANG->_('PHPSHOP_ADMIN_CFG_YES') ?></option>
	                <option <?php if (S4B_SINGLE_LANG != '1') echo "selected=\"selected\""; ?> value="0"><?php echo $VM_LANG->_('PHPSHOP_ADMIN_CFG_NO') ?></option>
                </select>
            </td>
            <td><?php echo PHPSHOP_ADMIN_S4B_MULTI_LANG_EXPLAIN ?>
        </tr>

        <tr>
            <td><strong><?php echo PHPSHOP_ADMIN_CFG_S4B_STATUS_SUCCESS ?></strong></td>
            <td>
                <select name="S4B_VERIFIED_STATUS" class="inputbox" >
                <?php
                    $q = "SELECT order_status_name,order_status_code FROM #__{vm}_order_status ORDER BY list_order";
                    $db->query($q);
                    $order_status_code = Array();
                    $order_status_name = Array();
                    
                    while ($db->next_record()) {
                      $order_status_code[] = $db->f("order_status_code");
                      $order_status_name[] =  $db->f("order_status_name");
                    }
                    for ($i = 0; $i < sizeof($order_status_code); $i++) {
                      echo "<option value=\"" . $order_status_code[$i];
                      if (S4B_VERIFIED_STATUS == $order_status_code[$i]) 
                         echo "\" selected=\"selected\">";
                      else
                         echo "\">";
                      echo $order_status_name[$i] . "</option>\n";
                    }?>
                    </select>
            </td>
            <td><?php echo PHPSHOP_ADMIN_CFG_S4B_STATUS_SUCCESS_EXPLAIN ?>
            </td>
        </tr>
        <tr>
            <td><strong><?php echo PHPSHOP_ADMIN_CFG_S4B_STATUS_PENDING ?></strong></td>
            <td>
                <select name="S4B_PENDING_STATUS" class="inputbox" >
                <?php
                    for ($i = 0; $i < sizeof($order_status_code); $i++) {
                      echo "<option value=\"" . $order_status_code[$i];
                      if (S4B_PENDING_STATUS == $order_status_code[$i]) 
                         echo "\" selected=\"selected\">";
                      else
                         echo "\">";
                      echo $order_status_name[$i] . "</option>\n";
                    } ?>
                    </select>
            </td>
            <td><?php echo PHPSHOP_ADMIN_CFG_S4B_STATUS_PENDING_EXPLAIN ?>
            </td>
        </tr>
		
        <tr>
            <td><strong><?php echo PHPSHOP_ADMIN_CFG_S4B_STATUS_FAILED ?></strong></td>
            <td>
                <select name="S4B_CANCELLED_STATUS" class="inputbox" >
                <?php
                    for ($i = 0; $i < sizeof($order_status_code); $i++) {
                      echo "<option value=\"" . $order_status_code[$i];
                      if (S4B_CANCELLED_STATUS == $order_status_code[$i]) 
                         echo "\" selected=\"selected\">";
                      else
                         echo "\">";
                      echo $order_status_name[$i] . "</option>\n";
                    } ?>
                    </select>
            </td>
            <td><?php echo PHPSHOP_ADMIN_CFG_S4B_STATUS_FAILED_EXPLAIN ?>
            </td>
        </tr>
		
		<tr style="padding-top:15px;" >		
			<td style="font-weight:bold;font-size:16px;text-decoration:underline;" colspan=2 ><?php echo PHPSHOP_4B_MODULE_CFG ?></td>
			<td><?php echo PHPSHOP_4B_MODULE_CFG_EXPLAIN ?></td>
		</tr>	
		<tr>		
			<td  colspan=2 ><strong><?php echo PHPSHOP_4B_TXT_BREAKDOWN_URL ?>:</strong></td>
			<td><?php echo "  http://mysite.se/administrator/components/com_virtuemart/vm4b_requestdetails.php" ?></td>
        </tr>
		<tr>		
			<td colspan=2 ><strong><?php echo PHPSHOP_4B_TXT_PERMITTED_URL ?>:</strong></td>
			<td><?php echo "  http://mysite.se/administrator/components/com_virtuemart/vm4b_notify.php" ?></td>
        </tr>
		<tr>		
			<td colspan=2 ><strong><?php echo PHPSHOP_4B_TXT_DENIED_URL ?>:</strong></td>
			<td> <?php echo "  http://mysite.se/administrator/components/com_virtuemart/vm4b_notify.php" ?></td>
        </tr>
		<tr>		
			<td colspan=2  ><strong><?php echo PHPSHOP_4B_TXT_RECEIPT_URL ?>:</strong></td>
			<td><?php echo "  http://mysite.se/index.php?option=com_virtuemart&page=checkout.s4bthankyou" ?></td>
        </tr>
		
      </table>
    <?php
    }
    
    function has_configuration() {
      // return false if there's no configuration
      return true;
   }
   
  /**
	* Returns the "is_writeable" status of the configuration file
	* @param void
	* @returns boolean True when the configuration file is writeable, false when not
	*/
   function configfile_writeable() {
      return is_writeable( CLASSPATH."payment/".$this->classname.".cfg.php" );
   }
   
  /**
	* Returns the "is_readable" status of the configuration file
	* @param void
	* @returns boolean True when the configuration file is writeable, false when not
	*/
   function configfile_readable() {
      return is_readable( CLASSPATH."payment/".$this->classname.".cfg.php" );
   }
   
  /**
	* Writes the configuration file for this payment method
	* @param array An array of objects
	* @returns boolean True when writing was successful
	*/
   function write_configuration( &$d ) {

		if($d['S4B_SIMULATION_SITE'] == 1)
		{
			$S4B_SERVER_URL = $d['S4B_SIMULATION_URL'];
			$S4B_SERVER_IP  = $d['S4B_SIMULATION_IP'];
		}	
			
		else
		{
			$S4B_SERVER_URL = $d['S4B_PROD_SERVER_URL'];
			$S4B_SERVER_IP = $d['S4B_PROD_SERVER_IP'];
		}	
		
		$my_config_array = array(
	                            "S4B_DEBUG" => $d['S4B_DEBUG'],
	                            "S4B_EMAIL" => $d['S4B_EMAIL'],
	                            "S4B_VERIFIED_ONLY" => $d['S4B_VERIFIED_ONLY'],
	                            "S4B_VERIFIED_STATUS" => $d['S4B_VERIFIED_STATUS'],
	                            "S4B_PENDING_STATUS" => $d['S4B_PENDING_STATUS'],
	                            "S4B_CANCELLED_STATUS" => $d['S4B_CANCELLED_STATUS'],
								"S4B_SIMULATION_SITE" => $d['S4B_SIMULATION_SITE'],
	                            "S4B_EXT_LOG" => $d['S4B_EXT_LOG'],
	                            "S4B_STORE_ID" => $d['S4B_STORE_ID'],
								"S4B_STORE_PASSWORD" => $d['S4B_STORE_PASSWORD'],
	                            "S4B_TRANSACTION_LANG" => $d['S4B_TRANSACTION_LANG'],
	                            "S4B_SINGLE_LANG" => $d['S4B_SINGLE_LANG'],
	                            "S4B_SERVER_URL" => $S4B_SERVER_URL,
								"S4B_SERVER_IP" => $S4B_SERVER_IP,
								"S4B_SERVER_PROTOCOL" => 'https',
								"S4B_PROD_SERVER_URL" => $d['S4B_PROD_SERVER_URL'],
								"S4B_PROD_SERVER_IP" => $d['S4B_PROD_SERVER_IP'],
								"S4B_SIMULATION_URL" => $d['S4B_SIMULATION_URL'],
								"S4B_SIMULATION_IP" => $d['S4B_SIMULATION_IP'],
								"S4B_ADVANCE_SECURITY" => $d['S4B_ADVANCE_SECURITY'],
								"S4B_PUBLIC_KEY" => $d['S4B_PUBLIC_KEY'],
								"S4B_VENDOR_ID" => 1,
								"S4B_NO_ORDER_ID" => 'No order id specified',
								"S4B_DBASE_ERROR" => 'Database error: ',
								"S4B_DBASE_CON_ERROR" => 'Database connection error: ',
								"S4B_DBASE_PARAMS_ERROR" => 'Error getting database parameters',
								"S4B_INVALID_IP_ERROR" => 'Invalid IP address: ',
								"S4B_TRANS_TERMINATED" => ' Transaction Terminated ',
								"S4B_DETAIL_REQ" => 'details requested',
								"S4B_DETAIL_COMP" => 'Transaction completes',
								"S4B_DETAIL_SENT" => 'details sent',
								"S4B_NO_CURR_CODE" => 'Error accessing ISO 4217 3 digit currency code',
                            );
      $config = "<?php\n";
      $config .= "defined( '_JEXEC' ) or die('Direct Access to this location is not allowed.'); \n\n";
      foreach( $my_config_array as $key => $value ) {
        $config .= "define ('$key', '$value');\n";
      }
      
      $config .= "?>";
  
      if ($fp = fopen(CLASSPATH ."payment/".$this->classname.".cfg.php", "w")) {
          fputs($fp, $config, strlen($config));
          fclose ($fp);
          return true;
     }
     else
        return false;
   }
   
  /**************************************************************************
  ** name: process_payment()
  ** returns: 
  ***************************************************************************/
   function process_payment($order_number, $order_total, &$d) {
        return true;
    }
   
}

?>